<?php
define('_onlinecontractstripe_version_num', '2.0');
?>
<?php
/*
 * Plugin Name: Online Contract Stripe Payments
 * Plugin URI: https://www.futuredesigngroup.com/downloads/wp-online-contract-stripe-payments
 * Description: Add Stripe payment functionality to your Wordpress Online Contract management plugin.
 * Version: 2.0
 * Author: Future Design Group
 * Author URI: http://futuredesigngroup.com
 * License: GPL2
 * Copyright 2014  Future Design Group  (email : olivere@futuredesigngroup.com)
 */
 
/*
LICENSE

Copyright 2014 Future Design Group <olivere@futuredesigngroup.com>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.	 See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place, Suite 330, Boston, MA 02111-1307 USA
*/

/*
Contributors:
-------------
Original author: Eric Oliver <olivere@futuredesigngroup.com>
*/

if( is_admin()){
	
	/*Add PayPal settings to admin submenu*/
	add_action('admin_menu', '_onlinecontract_stripesettings');

	function _onlinecontract_stripesettings() {

		add_submenu_page( 'edit.php?post_type=contract',  'Stripe&trade;',  'Stripe&trade;', 'manage_options', 'stripe_settings', 'stripe_settings' ); 
		
	}

	/*Populate PayPal settings page*/
	function stripe_settings() { ?>

		<div class="wrap">
			<h2>Stripe&trade; Settings</h2>
			<?php _onlinecontract_getadminnotification(); ?>
		</div>
		
	<?php 
	
		echo _onlinecontract_getpayments('stripe');
	
	}
	
	function _onlinecontract_stripe_method() {
	
		/*Get values from previously submitted options*/
		$_onlinecontract_stripepublicapi = get_option('onlinecontractstripe_publicapi');
		
		$_onlinecontract_stripeprivateapi = get_option('onlinecontractstripe_privateapi');
		
		$_onlinecontract_stripefee = get_option('onlinecontract_contractstripefee');
		
		$_onlinecontract_stripebuttonlabel = get_option('onlinecontract_contractstripelabel'); 
		
		?>
		
		<div id="onlinecontract-settings">
			<form action="options.php" method="post" name="options" enctype="multipart/form-data">
				<?php echo wp_nonce_field('update-options'); ?>
				<table class="form-table" width="100%" cellpadding="10">
					<tr>
						<th><label for="onlinecontractstripe_publicapi">Public API Key</label></th>
						<td><input type="text" name="onlinecontractstripe_publicapi" id="onlinecontractstripe_publicapi" value="<?php echo $_onlinecontract_stripepublicapi; ?>" size="30" style="width:97%;"><br><small>Enter your public API key (located <a href="https://manage.stripe.com/account/apikeys" target="_blank">here</a>)</small></td>
					</tr>
					<tr>
						<th><label for="onlinecontractstripe_privateapi">Private API Key</label></th>
						<td><input type="text" name="onlinecontractstripe_privateapi" id="onlinecontractstripe_privateapi" value="<?php echo $_onlinecontract_stripeprivateapi; ?>" size="30" style="width:97%;"><br><small>Enter your secret API key (located <a href="https://manage.stripe.com/account/apikeys" target="_blank">here</a>)</small></td>
					</tr>
					<tr>
						<th><label for="onlinecontract_contractstripefee">Charge A Fee</label></th>
						<td><input type="text" name="onlinecontract_contractstripefee" id="onlinecontract_contractstripefee" value="<?php echo $_onlinecontract_stripefee; ?>" size="30" style="width:50%;"><br><small>You can charge a fee to use Stripe (ex: 2.50 or 2.9%)</small></td>
					</tr>
					<tr>
						<th><label for="onlinecontract_contractstripelabel">Button Label</label></th>
						<td><input type="text" name="onlinecontract_contractstripelabel" id="onlinecontract_contractstripelabel" value="<?php echo $_onlinecontract_stripebuttonlabel; ?>" size="30" style="width:97%;"><br><small>Enter the label that will appear on the button.</small></td>
					</tr>
				</table>
				<input type="hidden" name="action" value="update" />
				<input type="hidden" name="page_options" value="onlinecontractstripe_publicapi,onlinecontractstripe_privateapi,onlinecontract_contractstripefee,onlinecontract_contractstripelabel" />
				<div style="float:right; padding-top:8px; width: 40%; text-align: right;">Version <?php echo _onlinecontractstripe_version_num; ?> </div>
				<input type="submit" name="btnupdatestripe" id="btnupdatestripe" value="Update Settings" class="button-primary" />
			</form>
		</div>
		
		<div id="onlinecontract-infotext">
			<h3>Stripe Payment Integration</h3>
			<p>Thank you for using our Stripe payments addon for our Online Contract plugin. Remember, this plugin will only work with our WP Online Contract plugin.  If you purchased this plugin without that plugin, you can purchase our contract plugin using the following link:<br>
			<a href="http://codecanyon.net/item/wp-online-contract/7698011?ref=futuredesigngrp" target="_blank" onclick="return makesureSave();">http://codecanyon.net/item/wp-online-contract/7698011</a></p>
			<p>Please rate this plugin if you like how it functions and if it helps you create unique, usable contracts and helps you get paid with Dwolla.</p>
			<p>Interested in more of our plugins? Please take a look at our CodeCanyon portfolio for all of our plugins and code:<br>
			<a href="http://codecanyon.net/user/futuredesigngrp/portfolio?ref=futuredesigngrp" target="_blank" onclick="return makesureSave();">http://codecanyon.net/user/futuredesigngrp/portfolio</a></p>
			<h3>About Stripe</h3>
			<p>Stripe is a developer-friendly way to accept payments online and in mobile apps. We process billions of dollars a year for thousands of companies of all sizes.</p>
			<p><a href="https://stripe.com/about" target="_blank" onclick="return makesureSave();">Read more about Stripe</a></p>
			<h3>Signup for Stripe</h3>
			<p>Don't have a Stripe account? No problem.  Sign up on their website using the link below:<br>
			<a href="https://dashboard.stripe.com/register" target="_blank" onclick="return makesureSave();">www.stripe.com</a></p>
			<h3>Get Your Stripe Keys</h3>
			<p>Click the following link to retrieve your public and secret keys. If you have admin access, they should be present in your account.  If not, you may only have read write acess and you will have to contact your developer r the person that setup your account to access the API keys for you. In order for this plugin to work properly and process charges, both keys are required.</p>
			<p>Please select the <strong>"live"</strong> keys in order to make your plugin payments live.  You can test using the test keys, but you will not be able to process live credit cards until you have entered the live keys.<br><a href="https://dashboard.stripe.com/account/apikeys" target="_blank" onclick="return makesureSave();">https://dashboard.stripe.com/account/apikeys</a></p>
			<h3>Need More Payment Methods?</h3>
			<hr>
			<p>Please see our <a href="http://codecanyon.net/user/futuredesigngrp/portfolio?ref=futuredesigngrp" onclick="return makesureSave();" target="_blank">portfolio</a>  for more payment processing plugins built by Future Design Group for our WP Online Contract plugin.</p>
		</div>
		
		<?php
		
	}
	
	add_action( '_onlinecontract_stripe_method', '_onlinecontract_stripe_method' );
}

/*Add PayPal button to contract and place custom label*/
function _onlinecontract_stripe_button($paymentargs) { 
	if(get_option('onlinecontract_contractstripefee')) {
		if (strpos(get_option('onlinecontract_contractstripefee'), '%') !== false) {
			$percentage = str_replace('%','',get_option('onlinecontract_contractstripefee'));
			$percentage = $paymentargs[0] * ($percentage/100);
			$stripe_fee = $percentage;
			$amount = $paymentargs[0] + $stripe_fee;
		}else{
			$stripe_fee= get_option('onlinecontract_contractstripefee');
			$amount = $paymentargs[0]+ $stripe_fee;
		}
	}else{
		$amount = $paymentargs[0];
	}
	$amount = number_format((float)$amount, 2, '.', '');
	$amount = $amount * 100;
	echo '<form action="#bottom" method="post" style="display: inline-block;">
			<input class="button-primary" data-amount="'.$amount.'" data-currency="'.get_option('onlinecontract_contractcurrencytype').'" data-description="'.$paymentargs[2].'" data-key="'.get_option('onlinecontractstripe_publicapi').'" data-name="'.get_option('onlinecontract_businessname').'" id="onlinecontractstripepayment" type="submit" value="'.get_option('onlinecontract_contractstripelabel').'">
			<script src="https://checkout.stripe.com/v2/checkout.js"></script> 
			<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.js"></script> <script>
					var $ = jQuery;
					$(document).ready(function() {
						$("#onlinecontractstripepayment").on("click", function(event) {
							event.preventDefault();
							var button = $(this),
								form = button.parents("form");
							var opts = $.extend({}, button.data(), {
								token: function(result) {
									form.append($("<input>").attr({ type: "hidden", name: "stripeToken", value: result.id })).submit();
								}
							});
							StripeCheckout.open(opts);
						});
					});
			</script>
		</form> ';
	if($_POST['stripeToken']) {

		require_once(WP_PLUGIN_DIR.'/wp-online-contract-stripe-payments/includes/lib/Stripe.php');

		Stripe::setApiKey(get_option('onlinecontractstripe_privateapi'));

		$token = $_POST['stripeToken'];

		try {

			$charge = Stripe_Charge::create(array(

			  "amount" => $amount*100,

			  "currency" => get_option('onlinecontract_contractcurrencytype'),

			  "card" => $token,

			  "description" => $paymentargs[2])

			);

		} catch (Stripe_ApiConnectionError $e) {

			// Network problem, perhaps try again.

			 $e_json = $e->getJsonBody();

			 $error = $e_json['error'];

		} catch (Stripe_InvalidRequestError $e) {

			// You screwed up in your programming. Shouldn't happen!

			 $e_json = $e->getJsonBody();

			 $error = $e_json['error'];

		} catch (Stripe_ApiError $e) {

			// Stripe's servers are down!

			 $e_json = $e->getJsonBody();

			 $error = $e_json['error'];

		} catch (Stripe_CardError $e) {

			// Card was declined.

			 $e_json = $e->getJsonBody();

			 $error = $e_json['error'];

		}

	}
}

add_filter( '_onlinecontract_getpaymentbuttons', '_onlinecontract_stripe_button' );

/*Add PayPal fee is user adds one*/
function _onlinecontract_stripe_fee() { 
	
	if(get_option('onlinecontract_contractstripefee')) {
		if (strpos(get_option('onlinecontract_contractstripefee'), '%') === false) {
			$currencysymbol = get_option('onlinecontract_contractcurrency');
		}
		echo 'There is a '.$currencysymbol.get_option('onlinecontract_contractstripefee').' convenience fee to use Stripe to pay your contract online.<br>';
	}
	
}

add_filter( '_onlinecontract_getpaymentfees', '_onlinecontract_stripe_fee' );
?>